//
// Created by servostar on 09.12.23.
//

#include "adc.h"
#include <stdlib.h>

void adc_init() {
    DDRC = 0x0;
    SET_BIT(ADCSRA, ADEN); // enable ADC

    // set prescaler / precision for conversion
    SET_BIT(ADCSRA, ADPS0);
    SET_BIT(ADCSRA, ADPS1);
    SET_BIT(ADCSRA, ADPS2);

    // set reference voltage
    SET_BIT(ADMUX, REFS0);
}

uint16_t adc_read(uint8_t channel) {
    ADMUX &= 0xF0;
    ADMUX |= (channel & 0xF0);
    // trigger adc conversion
    ADCSRA |= (1 << ADSC);
    // wait until converted
    while((ADCSRA & (1 << ADIF)) == 0);
    return ADCL + (ADCH << 8);
}

static uint16_t recent_adc = 0;

void init() {
    uart_init(9600);
    adc_init();
}

void loop() {
    uint16_t adc_val = adc_read(0);
    char buf[10] = { 0 };
    itoa(adc_val, buf, 10);

    if (recent_adc != adc_val) {
        recent_adc = adc_val;

        uart_write_string("Channel 0: ");
        uart_write_string(buf);
        uart_write_string("\n");
    }
}